#ifndef CSPACE_THREAD_H
#define CSPACE_THREAD_H

#ifdef WIN32
#include <windows.h>
#else
#include <pthread.h>
#endif

//thread interface class - per-OS
class Thread {
//protected:
public:

#ifdef WIN32
	HANDLE thread;
#else
	pthread_t thread;
#endif

	int (*callback)();
	
//public:

	Thread(int (*_callback)() = 0) : thread(0), callback(_callback) {}

	virtual bool init();
	
	virtual int run();
	bool isDone();
		
	enum Priority {
		PRIORITY_TIME_CRITICAL,
		PRIORITY_HIGHEST,
		PRIORITY_ABOVE_NORMAL,
		PRIORITY_NORMAL,
		PRIORITY_BELOW_NORMAL,
		PRIORITY_LOWEST,
		PRIORITY_ABOVE_IDLE,
		PRIORITY_IDLE,
		PRIORITY_COUNT
	};
	void setPriority(Priority priority);
	
	//sdl threads anyone?
	bool wait();

	void sleep(long ms = 0);
};

#endif //CSPACE_THREAD_H
